<?php
/**
 * ------------------------------------------------------------------------
 * JA AVTracklist Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */

// No direct access allowed to this file
defined( '_JEXEC' ) or die( 'Restricted access' );
 
// Import Joomla! Plugin library file
jimport('joomla.plugin.plugin');
 
//The Content plugin HTML Media
class plgContentJaavtracklist extends JPlugin{
    protected $_plgCode = "#{jamedia[^>]+}#iU";
    protected $_skin = "muzic.skin";
    var $plugin;
    var $doc;
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
        $this->plugin = JPluginHelper::getPlugin('content', 'jaavtracklist');
        $this->_skin = $this->params->def('skin', 'muzic.skin');
        $this->doc = JFactory::getDocument();
		$this->loadLanguage();
	}
	
	/**
	 * Plugin that transforms joomla plugin code to html5 media elements
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0){
        require_once(dirname(__FILE__).'/assets/behavior.php');
        JHTML::_('behavior.framework', true);
        JHTML::_('behavior.modal');
        JHTML::_('JABehavior.jquery');

        $doc = JFactory::getDocument();
        $plugin = $this->plugin;

        $basepath = JURI::root(true).'/plugins/' . $plugin->type . '/' . $plugin->name . '/';
		// Don't run this plugin when the content is being indexed
        //Show only content component

        if ($context == 'com_finder.indexer') {
            $article->text = $this->removeCode($article->text);
            return true;
        }

		// simple performance check to determine whether bot should process further
		if (strpos($article->text, '{jamedia') === false) {
			return true;
		}

        if(isset($article->text)){
            //Show in categories article
            //Check load js library
            if (!defined('_PLG_CONTENT_TRACKS_ASSETS_')) {
                define('_PLG_CONTENT_TRACKS_ASSETS_', 1);
                //Load js library
                $doc->addScript($basepath.'mediaplayer/js/jquery.jplayer.min.js');
                $doc->addScript($basepath.'mediaplayer/js/jplayer.playlist.min.js');
                //Load css skin
                $doc->addStyleSheet($basepath.'mediaplayer/skin/'.$this->_skin.'/jplayer.'.$this->_skin.'.css');
            }

            $media = $this->parseString($article->text);
            
            foreach($media as $key=>$val){
                if(isset($val['type'])){
                    $val['plid'] = uniqid();
                    switch($val['type']){
                        case 'audio':
                            if($context == 'com_content.article' || $context == 'com_k2.item'){
                                $article->text = str_replace($key,$this->getAudio($val),$article->text);
                            }else{
                                $article->text = str_replace($key,$this->getAudioMini($val),$article->text);
                            }
                            break;
                        case 'video':
                            if($context == 'com_content.category'){
                                $article->text = $this->getVideoThumbs($val);
                            }else if($context == 'com_content.article'){
                                $article->text = str_replace($key,$this->getVideo($val),$article->text);
                            }
                            break;
                        case 'album':
                            if($context == 'com_content.article' || $context == 'com_k2.item'){
                                $article->text = str_replace($key,$this->getAlbum($val),$article->text);
                            }
                            break;
                        default:
                            break;
                    }
                }
            }
            //Remove code text
            $article->text = $this->removeCode($article->text);
            return true;
        }
        $article->text = $this->removeCode($article->text);
	}
    public function getVideoThumbs($value){
        $plugin = $this->plugin;
        $context = '';
        $imgpath = '';
        if(isset($value['poster']) && $value['poster'] !=''){
			$imgclass = 'poster-images';
            $imgpath = $this->validURL($value['poster']);
        }else{
            switch($value['mtype']){
                case 'vimeo':
                    $thumb = preg_replace('|(vimeo.com/([a-zA-Z0-9_-]+))|e', '$this->vimeoThumb("\2")', $value['src']);
					if($this->getVimeoThumb($thumb)){
						$imgpath = $this->getVimeoThumb($thumb);
					}else{
						$imgpath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/assets/images/default_video.png';
						$imgclass = 'default-images';
					}               
					$imgclass = 'vimeo-images';
                    break;
                case 'youtube':
                    $imgpath = str_replace('www.','',preg_replace('|(youtube.com/watch\?v=([a-zA-Z0-9_-]+))|e', '$this->youtubeThumb("\2")', $value['src']));
					$file_headers = @get_headers($imgpath);
					if($file_headers[0] == 'HTTP/1.1 404 Not Found') {
						$imgpath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/assets/images/default_video.png';
						$imgclass = 'default-images';
					}
					else {
						$imgclass = 'youtube-images';
					}
					break;
                default:
                    $imgpath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/assets/images/default_video.png';
					$imgclass = 'default-images';
                    break;
            }
        }
        $videothumbsPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/skin/'.$this->_skin.'/default_video_thumbs.php';
        if(!file_exists($videothumbsPath)){
            $videothumbsPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/tmpl/default_video_thumbs.php';
        }
        $title = '';
        if(isset($value['title'])) $title =  $value['title'];
        ob_start();
        require ($videothumbsPath);
        $context = ob_get_contents();
        ob_end_clean();
        return $context;
    }
    function youtubeThumb($vCode){
        return 'img.youtube.com/vi/'.$vCode.'/0.jpg';
    }
    function vimeoThumb($vCode){
        return 'vimeo.com/api/v2/video/'.$vCode.'.json';
    }
    function getVimeoThumb($data) {
		if (false !== ($contents = @file_get_contents($data,true))) {
			$contents = json_decode($contents);
			return $contents[0]->thumbnail_large;
		} else {
			return;
		}
    }

    public function getAudioMini($value){

        $plugin = $this->plugin;
        $context = '';
        $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/skin/'.$this->_skin.'/default_audio_mini.php';
        if(!file_exists($audioPath)){
            $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/tmpl/default_audio_mini.php';
        }
		$swfPath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/js';
        if(isset($value['src']) && isset($value['mtype'])){
            $value['src'] = $this->validURL($value['src']);
			$plid = $value['plid'];
            $script = "
            (function($){
            	$(document).ready(function(){
            		$('#jquery_jplayer_".$plid."').jPlayer( {
						ready: function(event) {
							$(this).jPlayer('setMedia', {".$value['mtype'].":'".$value['src']."'});
						},
						swfPath: '".$swfPath."',
						supplied: '".$value['mtype']."',
						play: function() {
							// To avoid multiple jPlayers playing together.
							$(this).jPlayer('pauseOthers');
						},
						wmode: 'window',
						cssSelectorAncestor: '#jp_container_".$value['plid']."',
						smoothPlayBar: true,
						keyEnabled: true,
						consoleAlerts: true,
						errorAlerts: true,
						warningAlerts: false
					});
				});
			})(jQuery);";
            $this->doc->addScriptDeclaration($script);
            $title = '';
            if(isset($value['title'])) $title =  $value['title'];
            ob_start();
            require ($audioPath);
            $context = ob_get_contents();
            ob_end_clean();
            return $context;
        }
    }
    public function getAudio($value){
        $plugin = $this->plugin;
        $context = '';
        $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/skin/'.$this->_skin.'/default_audio.php';
        if(!file_exists($audioPath)){
            $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/tmpl/default_audio.php';
        }
		$swfPath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/js';
        if(isset($value['src']) && isset($value['mtype'])){
            $value['src'] = $this->validURL($value['src']);
            $script = '(function($){
                        $(document).ready(function(){

                            $("#jquery_jplayer_'.$value['plid'].'").jPlayer({
                                ready: function (event) {
                                    $(this).jPlayer("setMedia", {
                                        '.$value['mtype'].':"'.$value['src'].'"'.'
                                    });
                                },
                                swfPath: "'.$swfPath.'",
                                supplied: "'.$value['mtype'].'",
								play: function() {
									// To avoid multiple jPlayers playing together.
									$(this).jPlayer("pauseOthers");
								},
                                wmode: "window",
                                cssSelectorAncestor: "#jp_container_'.$value['plid'].'",
                                smoothPlayBar: true,
                                keyEnabled: true
                            });
                        });
                    })(jQuery);';
            $this->doc->addScriptDeclaration($script);
            $title = '';
            if(isset($value['title'])) $title =  $value['title'];
            $plid = $value['plid'];
            ob_start();
            require ($audioPath);
            $context = ob_get_contents();
            ob_end_clean();
            return $context;
        }
    }
    function youtubeCodeEmbed($vCode){
        return 'youtube.com/embed/'.$vCode;
    }
    function videoCodeEmbed($vCode){
        return 'player.vimeo.com/video/'.$vCode;
    }
    public function getVideo($value){
        $plugin = $this->plugin;
        $context = '';
        $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/skin/'.$this->_skin.'/default_video.php';
        if(!file_exists($audioPath)){
            $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/tmpl/default_video.php';
        }

		$swfPath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/js';
        if(isset($value['src']) && isset($value['mtype'])){

            $width = '640';
            if(isset($value['width'])) $width = $value['width'];

            $height = '360';
            if(isset($value['height'])) $height = $value['height'];

            switch($value['mtype']){
                case 'youtube':
                    $value['src'] = preg_replace('|(youtube.com/watch\?v=([a-zA-Z0-9_-]+))|e', '$this->youtubeCodeEmbed("\2")', $value['src']);
                    $context = '<iframe width="'.$width.'" height="'.$height.'" src="'.$value['src'].'" frameborder="0" allowfullscreen></iframe>';
                    return $context;
                    break;
                case 'vimeo':
                    $value['src'] = preg_replace('|(vimeo.com/([a-zA-Z0-9_-]+))|e', '$this->videoCodeEmbed("\2")', $value['src']);
                    $context = '<iframe width="'.$width.'" height="'.$height.'" src="'.$value['src'].'" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
                    return $context;
                    break;
                default:
                    $poster = '';
                    if(isset($value['poster'])) $poster = ', poster:"'.$this->validURL($value['poster']).'"';
                    $value['src'] = $this->validURL($value['src']);
                    $script = '(function($){
                        $(document).ready(function(){
                            $("#jquery_jplayer_'.$value['plid'].'").jPlayer({
                                ready: function (event) {
                                    $(this).jPlayer("setMedia", {
                                        '.$value['mtype'].':"'.$value['src'].'"'.'
                                        '.$poster.'
                                    });
                                },
                                swfPath: "'.$swfPath.'",
                                supplied: "'.$value['mtype'].'",
                                size: {
                                    width: "'.$width.'px",
                                    height: "'.$height.'px"
                                },
                                wmode: "window",
                                cssSelectorAncestor: "#jp_container_'.$value['plid'].'",
                                smoothPlayBar: true,
                                keyEnabled: true
                            });
                        });
                    })(jQuery);';
                    $this->doc->addScriptDeclaration($script);
                    $title = '';
                    if(isset($value['title'])) $title=$value['title'];
                    $plid = $value['plid'];
                    ob_start();
                    require ($audioPath);
                    $context = ob_get_contents();
                    ob_end_clean();
                    return $context;
                    break;
            }
        }
    }
    public function getAlbum($value){

        $plugin = $this->plugin;
        $context = '';
        if(isset($value['id'])){
            $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/skin/'.$this->_skin.'/default_album.php';
            if(!file_exists($audioPath)){
                $audioPath = JPATH_BASE . '/plugins/' . $plugin->type . '/' . $plugin->name . '/tmpl/default_album.php';
            }
			$swfPath = JURI::base(true) . '/plugins/' . $plugin->type . '/' . $plugin->name . '/mediaplayer/js';
            $ids = explode(',',$value['id']);
            $playlist ='[';
            $i=0;
            foreach($ids as $id){
                if(is_numeric($id)){
                    $texts = $this->getItemsById($id);
                    if(isset($texts)){
                        $text = $texts->introtext.$texts->fulltext;

                        if (!(strpos($text, '{jamedia') === false)) {
                            if($i >0) $playlist .=',';
                            $media = $this->parseString($text);
                            $j = 0;
                            foreach($media as $key=>$val){
                                if(isset($val['type']) && $val['type'] == 'audio'){
                                    if($j >0) $playlist .=',';
                                    $poster = '';
                                    if(isset($val['poster'])) $poster = ', poster:"'.$this->validURL($val['poster']).'"';
                                    $title ='';
                                    if(isset($val['title'])) $title = ', title:"'.$val['title'].'"';
                                    $val['src'] = $this->validURL($val['src']);
                                    $playlist .= '{
                                    '.$val['mtype'].':"'.$val['src'].'"'.'
                                    '.$poster.'
                                    '.$title.'
                                }';

                                    $j++;
                                }
                            }
                            $i++;
                        }
                    }
                }
            }
            $playlist .=']';

            $plid = $value['plid'];

            $script = '(function($){
                        $(document).ready(function(){
                            new jPlayerPlaylist({
                                jPlayer: "#jquery_jplayer_'.$plid.'",
                                cssSelectorAncestor: "#jp_container_'.$plid.'"
                            },'.$playlist.' , {
                                swfPath: "'.$swfPath.'",
                                supplied: "oga, mp3",
                                smoothPlayBar: true,
                                keyEnabled: true,
                                audioFullScreen: true
                            });
                        });
                    })(jQuery);';
            $this->doc->addScriptDeclaration($script);
            ob_start();
            require ($audioPath);
            $context .= ob_get_contents();
            ob_end_clean();
        }
        return $context;
    }
    public function getItemsById($pk){
        $db = jFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('a.id, a.asset_id, a.title, a.alias, a.introtext, a.fulltext, ' .
                // If badcats is not null, this means that the article is inside an unpublished category
                // In this case, the state is set to 0 to indicate Unpublished (even if the article state is Published)
                'CASE WHEN badcats.id is null THEN a.state ELSE 0 END AS state, ' .
                ' a.catid, a.created, a.created_by, a.created_by_alias, ' .
                // use created if modified is 0
                'CASE WHEN a.modified = 0 THEN a.created ELSE a.modified END as modified, ' .
                'a.modified_by, a.checked_out, a.checked_out_time, a.publish_up, a.publish_down, ' .
                'a.images, a.urls, a.attribs, a.version,  a.ordering, ' .
                'a.metakey, a.metadesc, a.access, a.hits, a.metadata, a.featured, a.language, a.xreference'

        );
        $query->from('#__content AS a');

        // Join on category table.
        $query->select('c.title AS category_title, c.alias AS category_alias, c.access AS category_access');
        $query->join('LEFT', '#__categories AS c on c.id = a.catid');

        // Join on user table.
        $query->select('u.name AS author');
        $query->join('LEFT', '#__users AS u on u.id = a.created_by');

        // Get contact id
        $subQuery = $db->getQuery(true);
        $subQuery->select('MAX(contact.id) AS id');
        $subQuery->from('#__contact_details AS contact');
        $subQuery->where('contact.published = 1');
        $subQuery->where('contact.user_id = a.created_by');

        $query->select('(' . $subQuery . ') as contactid');



        // Join over the categories to get parent category titles
        $query->select('parent.title as parent_title, parent.id as parent_id, parent.path as parent_route, parent.alias as parent_alias');
        $query->join('LEFT', '#__categories as parent ON parent.id = c.parent_id');

        // Join on voting table
        $query->select('ROUND(v.rating_sum / v.rating_count, 0) AS rating, v.rating_count as rating_count');
        $query->join('LEFT', '#__content_rating AS v ON a.id = v.content_id');

        $query->where('a.id = ' . (int) $pk);

        // Filter by start and end dates.
        $nullDate = $db->Quote($db->getNullDate());
        $date = JFactory::getDate();

        $nowDate = $db->Quote($date->toSql());

        $query->where('(a.publish_up = ' . $nullDate . ' OR a.publish_up <= ' . $nowDate . ')');
        $query->where('(a.publish_down = ' . $nullDate . ' OR a.publish_down >= ' . $nowDate . ')');

        // Join to check for category published state in parent categories up the tree
        // If all categories are published, badcats.id will be null, and we just use the article state
        $subquery = ' (SELECT cat.id as id FROM #__categories AS cat JOIN #__categories AS parent ';
        $subquery .= 'ON cat.lft BETWEEN parent.lft AND parent.rgt ';
        $subquery .= 'WHERE parent.extension = ' . $db->quote('com_content');
        $subquery .= ' AND parent.published <= 0 GROUP BY cat.id)';
        $query->join('LEFT OUTER', $subquery . ' AS badcats ON badcats.id = c.id');

        // Filter by published state.
        $published = 1;

        if (is_numeric($published)) {
            $query->where('(a.state = ' . (int) $published . ')');
        }
        $db->setQuery($query);

        $data = $db->loadObject();
        return $data;
    }
    public function validURL($url){
        if (preg_match("/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i", $url)) {
            return $url;
        }
        else {
            return JURI::base().$url;
        }
    }
    public function removeCode($content)
    {
        return preg_replace($this->_plgCode, '', $content);
    }

    public function parseString($content){
        if (preg_match_all($this->_plgCode, $content, $matches)) {
            foreach($matches[0] as $m){
                $data[$m] = JUtility::parseAttributes($m);
            }
            return $data;
        }
        return null;
    }
    /**
     *
     * Parse Params to array
     * @param string $string
     * @return array
     */
    function parseParams($string)
    {
        $string = html_entity_decode($string, ENT_QUOTES);
        $regex = "/\s*([^=\s]+)\s*=\s*('([^']*)'|\"([^\"]*)\"|([^\s]*))/";
        $params = null;
        if (preg_match_all($regex, $string, $matches)) {
            for ($i = 0; $i < count($matches[1]); $i++) {
                $key = $matches[1][$i];
                $value = $matches[3][$i] ? $matches[3][$i] : ($matches[4][$i] ? $matches[4][$i] : $matches[5][$i]);
                $params[$key] = $value;
            }
        }
        return $params;
    }
}


